"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }



var _chunkB7DK75O3cjs = require('./chunk-B7DK75O3.cjs');

// src/index.ts
var _httpsnippet = require('@readme/httpsnippet');
var _oastohar = require('@readme/oas-to-har'); var _oastohar2 = _interopRequireDefault(_oastohar);
function oasToSnippet(oas, operation, values, auth, lang, opts = {}) {
  let config;
  let language;
  let target;
  const plugins = opts.plugins || [];
  const languages = _chunkB7DK75O3cjs.getSupportedLanguages.call(void 0, {
    plugins
  });
  try {
    ({ config, language, target } = _chunkB7DK75O3cjs.getLanguageConfig.call(void 0, languages, lang));
  } catch (err) {
    if (!language || !target) {
      return { code: "", highlightMode: false, install: false };
    }
  }
  if (!config) {
    throw new Error(
      `The supplied language \`${lang.toString()}\` is not supported. If a plugin powers this language please initialize that plugin with the \`plugins\` option.`
    );
  }
  if (!language || !target) {
    return { code: "", highlightMode: false, install: false };
  }
  const har = opts.harOverride || _oastohar2.default.call(void 0, oas, operation, values, auth);
  const snippet = new (0, _httpsnippet.HTTPSnippet)(har, {
    // We should only expect HAR's generated with `@readme/oas-to-har` to already be encoded.
    harIsAlreadyEncoded: !opts.harOverride
  });
  let targetOpts = config.httpsnippet.targets[target].opts || {};
  const highlightMode = config.highlight;
  plugins.forEach((plugin) => {
    _httpsnippet.addClientPlugin.call(void 0, plugin);
    if (plugin.target === "node" && plugin.client.info.key === "api") {
      targetOpts.api = {
        definition: oas ? oas.getDefinition() : null,
        identifier: _optionalChain([opts, 'optionalAccess', _ => _.openapi, 'optionalAccess', _2 => _2.variableName]),
        registryURI: _optionalChain([opts, 'optionalAccess', _3 => _3.openapi, 'optionalAccess', _4 => _4.registryIdentifier])
      };
    }
  });
  const install = _chunkB7DK75O3cjs.getClientInstallationInstructions.call(void 0, languages, lang, _optionalChain([opts, 'optionalAccess', _5 => _5.openapi, 'optionalAccess', _6 => _6.registryIdentifier])) || false;
  try {
    const code = snippet.convert(language, target, targetOpts);
    return {
      code: code ? code[0] : false,
      highlightMode,
      install
    };
  } catch (err) {
    if (language !== "node" && target !== "api") {
      throw err;
    }
    targetOpts = config.httpsnippet.targets.fetch.opts || {};
    const code = snippet.convert(language, "fetch", targetOpts);
    return {
      code: code ? code[0] : false,
      highlightMode,
      install: false
    };
  }
}


exports.default = oasToSnippet;

module.exports = exports.default;
//# sourceMappingURL=index.cjs.map